## gmt-6.6.0-1.src.tar.gz

=== doc/rst/CMakeLists.txt ===
#
# Copyright (c) 1991-2025 by the GMT Team (https://www.generic-mapping-tools.org/team.html)
# See LICENSE.TXT file for copying and redistribution conditions.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; version 3 or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# Contact info: www.generic-mapping-tools.org
#-------------------------------------------------------------------------------

# reST documentation
if (SPHINX_FOUND)
	# Create configuration file
	configure_file (conf.py.in conf.py @ONLY)

	# Copy reST sources to build tree
	include (CopyDirIfDifferent)
	foreach (subdir source _static _templates)
		copy_dir_if_different (_docs_copy_rst_tree_${subdir}
			${CMAKE_CURRENT_SOURCE_DIR}/${subdir}/
			${CMAKE_CURRENT_BINARY_DIR}/${subdir})
		add_depend_to_target (docs_depends _docs_copy_rst_tree_${subdir})
	endforeach ()
	add_custom_target (_docs_rst_mkdir_verbatim
		COMMAND ${CMAKE_COMMAND} -E make_directory
		${CMAKE_CURRENT_BINARY_DIR}/source/_verbatim
		DEPENDS _docs_copy_rst_tree_source)

	add_custom_target (_docs_rst_mkdir_images
		COMMAND ${CMAKE_COMMAND} -E make_directory
		${CMAKE_CURRENT_BINARY_DIR}/source/_images
		DEPENDS _docs_copy_rst_tree_source)

	# Copy two C codes into the build tree, so that they can be included in the documentation
	add_custom_target (_docs_rst_src
		COMMAND ${CMAKE_COMMAND} -E copy
			${CMAKE_SOURCE_DIR}/src/gmt_common_longoptions.h
			${CMAKE_SOURCE_DIR}/src/blockmean.c
			${CMAKE_CURRENT_BINARY_DIR}/source/
			DEPENDS _docs_copy_rst_tree_source)
	add_depend_to_target (docs_depends _docs_rst_src)

	# clean target
	add_custom_target (_rst_clean
		# cmake<3.15 can't remove multiple directories using cmake -E remove_directory
		COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/_doctrees
		COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/_static
		COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/_templates
		COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/source
		COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/html
		COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/man
		COMMENT "Removing rst tree")
	# register with spotless target
	add_depend_to_target (spotless _rst_clean)

	# HTML build target
	add_custom_target (docs_html
		COMMAND ${SPHINX_EXECUTABLE} -q -b html
		-c "${CMAKE_CURRENT_BINARY_DIR}"
		-d "${CMAKE_CURRENT_BINARY_DIR}/_doctrees_html"
		${CMAKE_CURRENT_BINARY_DIR}/source
		${CMAKE_CURRENT_BINARY_DIR}/html
		2> "${CMAKE_CURRENT_BINARY_DIR}/html.log"
		COMMENT "Building HTML documentation...")
	add_dependencies (docs_html docs_depends)

	# Build and compress manpages
	if (GZIP)
		add_custom_target (docs_man
			COMMAND ${SPHINX_EXECUTABLE} -q -b man
			-c "${CMAKE_CURRENT_BINARY_DIR}"
			-d "${CMAKE_CURRENT_BINARY_DIR}/_doctrees_man"
			-t nosphinxdesign
			${CMAKE_CURRENT_BINARY_DIR}/source
			${CMAKE_CURRENT_BINARY_DIR}/man
			2> "${CMAKE_CURRENT_BINARY_DIR}/man.log"
			COMMAND ${GZIP} -9 -n -f ${CMAKE_CURRENT_BINARY_DIR}/man/*.?
			COMMENT "Building manpages...")
		add_dependencies (docs_man docs_depends)
	endif (GZIP)

	# Install targets for release documentation
	if (GIT_FOUND AND HAVE_GIT_VERSION)
		# HTML
		add_custom_target (_html_release
			COMMAND ${CMAKE_COMMAND} -E copy_directory
			${CMAKE_CURRENT_BINARY_DIR}/html/
			${GMT_RELEASE_PREFIX}/doc_release/html
			DEPENDS docs_html git_export_release)
		add_depend_to_target (gmt_release _html_release)
		# Manpages
		add_custom_target (_man_release
			COMMAND ${CMAKE_COMMAND} -E copy_directory
			${CMAKE_CURRENT_BINARY_DIR}/man/
			${GMT_RELEASE_PREFIX}/man_release
			DEPENDS docs_man git_export_release)
		add_depend_to_target (gmt_release _man_release)
	endif (GIT_FOUND AND HAVE_GIT_VERSION)
endif (SPHINX_FOUND)

# Install HTML documentation
if (EXISTS ${GMT_INSTALL_EXTERNAL_DOC})
	# Install documentation from external location
	set (_doc_source ${GMT_INSTALL_EXTERNAL_DOC})
	set (_doc_dest ${GMT_DOCDIR})
else (EXISTS ${GMT_INSTALL_EXTERNAL_DOC})
	# Install html from build tree
	set (_doc_source ${CMAKE_CURRENT_BINARY_DIR}/html)
	set (_doc_dest ${GMT_DOCDIR}/html)
endif (EXISTS ${GMT_INSTALL_EXTERNAL_DOC})

install (DIRECTORY ${_doc_source}/
	DESTINATION ${_doc_dest}
	COMPONENT Documentation
	USE_SOURCE_PERMISSIONS
	OPTIONAL)

# Install man (if available)
if (EXISTS ${GMT_INSTALL_EXTERNAL_MAN})
	# Install manpages from external location
	set (_man_source ${GMT_INSTALL_EXTERNAL_MAN})
else (EXISTS ${GMT_INSTALL_EXTERNAL_MAN})
	# Install manpages from build tree
	set (_man_source ${CMAKE_CURRENT_BINARY_DIR}/man)
endif (EXISTS ${GMT_INSTALL_EXTERNAL_MAN})

install (DIRECTORY ${_man_source}/
	DESTINATION ${GMT_MANDIR}/man1
	COMPONENT Runtime
	FILES_MATCHING PATTERN "*.1.gz")

=== doc/scripts/CMakeLists.txt ===
#
# Copyright (c) 1991-2025 by the GMT Team (https://www.generic-mapping-tools.org/team.html)
# See LICENSE.TXT file for copying and redistribution conditions.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; version 3 or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# Contact info: www.generic-mapping-tools.org
#-------------------------------------------------------------------------------

if (SPHINX_FOUND)
	# Copy PS sources for gmt release
	if (GIT_FOUND AND HAVE_GIT_VERSION)
		add_custom_target (_scripts_images_release
			COMMAND ${CMAKE_COMMAND} -E copy_directory
			${CMAKE_CURRENT_SOURCE_DIR}/images/
			${GMT_RELEASE_PREFIX}/doc/scripts/images
			DEPENDS git_export_release)
		add_depend_to_target (gmt_release _scripts_images_release)
	endif (GIT_FOUND AND HAVE_GIT_VERSION)

	if (GMT_DOCS_DEPEND_ON_GMT)
		set (_gmt_command ${GMT_BINARY_DIR}/${CMAKE_CFG_INTDIR}/src/gmt)
	else (GMT_DOCS_DEPEND_ON_GMT)
		set (_gmt_command gmt)
	endif (GMT_DOCS_DEPEND_ON_GMT)

	# Convert PS to PNG
	file (GLOB _scripts_ps2png RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/images/*.ps")
	set (_scripts_png)
	foreach (_ps ${_scripts_ps2png})
		get_filename_component (_fig ${_ps} NAME)
		string (REPLACE ".ps" ".png" _png_fig ${_fig})
		list (APPEND _scripts_png ${RST_BINARY_DIR}/_images/${_png_fig})
		add_custom_command (OUTPUT ${RST_BINARY_DIR}/_images/${_png_fig}
			COMMAND ${CMAKE_COMMAND} -E env
			GMT_SHAREDIR=${GMT_SOURCE_DIR}/share
			${_gmt_command} psconvert
			-A -P -E150 -Tg -Qg4 -Qt4
			-D${RST_BINARY_DIR}/_images
			${CMAKE_CURRENT_SOURCE_DIR}/${_ps}
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			DEPENDS gmt_for_img_convert _docs_rst_mkdir_images ${CMAKE_CURRENT_SOURCE_DIR}/${_ps})
	endforeach (_ps ${_scripts_ps2png})

	# Convert PS to PDF
	set (_scripts_ps2pdf images/GMT_RGBchart.ps images/GMT_App_F_stand+_iso+.ps images/GMT_App_F_symbol_dingbats.ps)
	set (_scripts_pdf)
	foreach (_ps ${_scripts_ps2pdf})
		get_filename_component (_fig ${_ps} NAME)
		string (REPLACE ".ps" ".pdf" _pdf_fig ${_fig})
		list (APPEND _scripts_pdf ${RST_BINARY_DIR}/_images/${_pdf_fig})
		add_custom_command (OUTPUT ${RST_BINARY_DIR}/_images/${_pdf_fig}
			COMMAND ${CMAKE_COMMAND} -E env
			GMT_SHAREDIR=${GMT_SOURCE_DIR}/share
			${_gmt_command} psconvert -A -P -Tf
			-D${RST_BINARY_DIR}/_images
			${CMAKE_CURRENT_SOURCE_DIR}/${_ps}
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			DEPENDS gmt_for_img_convert _docs_rst_mkdir_images ${CMAKE_CURRENT_SOURCE_DIR}/${_ps})
	endforeach (_ps ${_scripts_ps})

	# Convert script to verbatim txt
	file (GLOB _scripts_sh2txt RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/*.sh")
	set (_scripts_txt)
	foreach (_script ${_scripts_sh2txt})
		string (REPLACE ".sh" ".txt" _txt ${_script})
		list (APPEND _scripts_txt ${RST_BINARY_DIR}/_verbatim/${_txt})
		add_custom_command (OUTPUT ${RST_BINARY_DIR}/_verbatim/${_txt}
			COMMAND ${GMT_BINARY_DIR}/src/script2verbatim --strip-comments --ps2pdf
			${CMAKE_CURRENT_SOURCE_DIR}/${_script}
			${RST_BINARY_DIR}/_verbatim/${_txt}
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			DEPENDS script2verbatim _docs_rst_mkdir_verbatim ${CMAKE_CURRENT_SOURCE_DIR}/${_script})
	endforeach (_script)

	# Add build target
	add_custom_target (_docs_scripts_verbatim DEPENDS ${_scripts_txt})
	add_custom_target (_docs_html_scripts_fig DEPENDS ${_scripts_png} ${_scripts_pdf})
	add_depend_to_target (docs_depends _docs_html_scripts_fig _docs_scripts_verbatim)
endif (SPHINX_FOUND)

# run tests
file (GLOB _scripts_tests RELATIVE ${CMAKE_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/*.sh")
# GMT_-U.sh always fails
foreach (skip_test GMT_-U.sh GMT_encoding.sh gen_data_App_O.sh gen_data_dummy.sh)
	list (REMOVE_ITEM _scripts_tests doc/scripts/${skip_test})
endforeach()

# Remove GMT_latex.sh if latex or dvips not found
if (NOT LATEX_FOUND)
	list (REMOVE_ITEM _scripts_tests doc/scripts/GMT_latex.sh doc/scripts/GMT_slope2intensity.sh doc/scripts/GMT_seamount_density.sh)
endif (NOT LATEX_FOUND)

if (DO_TESTS AND BASH)
	foreach (_job ${_scripts_tests})
		add_test (NAME ${_job}
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			COMMAND ${BASH} ${CMAKE_BINARY_DIR}/test/gmtest ${_job})
	endforeach (_job)
endif (DO_TESTS AND BASH)

=== PKGBUILD ===
# Maintainer: Bruno Pagani <archange@archlinux.org>

pkgbase=gmt
pkgname=(gmt gmt-doc)
pkgver=6.6.0
pkgrel=1
pkgdesc="Generic Mapping Tools for manipulating and plotting geographic and cartesian data"
arch=(x86_64)
url="https://www.generic-mapping-tools.org"
license=(LGPL)
makedepends=(cmake blas curl ffmpeg fftw gdal geos ghostscript graphicsmagick lapack openmp netcdf pcre2 zlib python-sphinx)
source=(https://github.com/GenericMappingTools/gmt/releases/download/${pkgver}/${pkgname}-${pkgver}-src.tar.xz)
sha256sums=('18ac98b11b8fc924463ce5138385c02e9426780fba9ff63a991e2e8ecdbd1082')

build() {
  cmake -B build -S ${pkgname}-${pkgver} \
    -DCMAKE_BUILD_TYPE=Release \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DGMT_LIBDIR=lib \
    -DGMT_DATADIR=share/gmt \
    -DGMT_MANDIR=share/man \
    -DGMT_DOCDIR=share/doc/gmt \
    -DGMT_ENABLE_OPENMP=ON \
    -DGSHHG_ROOT=/usr/share/gmt/coast \
    -DDCW_ROOT=/usr/share/gmt/dcw \
    -DCOPY_GSHHG=OFF \
    -DCOPY_DCW=OFF \
    -DCMAKE_POLICY_VERSION_MINIMUM=3.5
  make -C build
}

package_gmt() {
  depends=(blas curl fftw gdal geos lapack openmp netcdf pcre2 zlib)
  optdepends=(
    'gmt-doc: documentation'
    'ffmpeg: generate movies'
    'ghostscript: convert PostScript outputs'
    'graphicsmagick: generate animated GIFs'
  )
#    'gmt-coast: coastlines'
#    'gmt-dcw: digital chart of the world polygon map'

  make -C build DESTDIR="${pkgdir}" install
  mv "${pkgdir}"/usr/share/doc "${srcdir}"/
}

package_gmt-doc() {
  install -d "${pkgdir}"/usr/share/
  mv doc "${pkgdir}"/usr/share/
}
